#include "project.h"
#include <stdlib.h>
#include "initialisatie.h"

/**********************************************************************
*       Globale Variabelen
***********************************************************************/
int gekozenkanaal = 3;
char chargekozenkanaal;
 

/**********************************************************************
*       Variabelen
***********************************************************************/
int resetmenubevestiging = True;

int toggle6 = 0;
int refresh61 = 0;
int refresh62 = 0;

/**********************************************************************
*       Functies
***********************************************************************/
int sBEVESTIGING(){
    if(inactive == 0){
    nextstate = menubevestiging(nextstate);
    }
    if(inactive == 1){
    nextstate = SELECTKANAAL;
    resetmenubevestiging = True;
    }
    
return (nextstate);
}

int menubevestiging(){
    
    if(resetmenubevestiging == True){
        QuadDec_SetCounter(1);
        encoder = 1;
        resetmenubevestiging = False;
        toggle6 = 0;
        writebevestiging();
    }
    
    encoder = QuadDec_GetCounter();
    
    
//        Als QD lager is dan 0 set de counter terug naar 0.
        if (encoder <= - 1){
            QuadDec_SetCounter(0);  
            encoder = 0 ;
        }
        
//        Als QD hoger is dan 1 zet counter terug naar 1.
        if (encoder >= 2){
            QuadDec_SetCounter(1); 
            encoder = 1;

        }
    
        refresh61 = encoder;       
        if(toggle6 == 1){
            toggle6 = 0;
            if(refresh61 != refresh62){
                writebevestiging();
                inactive = 0;
                InactivityTimer_WriteCounter(INACTIVETIMERVALUE);
            }
        }
        if(toggle6 == 0){
            toggle6 = 1;
            refresh62 = refresh61;
        }
    
    if(encoder == 1){ 
        if(button == False){
            nextstate = BEVESTIGING;
        }
        if(button == True){
            nextstate = SELECTKANAAL;
            InactivityTimer_WriteCounter(0);
            button = False;
            resetmenubevestiging = True;
        }
    }
    
    if(encoder == 0){ 
        if(button == False){
            nextstate = BEVESTIGING;
        }
        if(button == True){
            nextstate = STURING;
            button = False;
            resetmenubevestiging = True;
        }
    }
    return(nextstate);
}

int writebevestiging(){
    
    LCD_Position(0, 0u);
    LCD_PrintString("      KANAAL->     ");
    
    
    LCD_Position(1, 0u);
    LCD_PrintString("      ARMATUUR     ");
    
    LCD_Position(2, 0u);
    LCD_PrintString("      PROGRAMMA    ");
    
    
    if(encoder == 1){
    LCD_Position(3, 0u);
    LCD_PrintString("      ja  >NEE      ");
    }
    if(encoder == 0){
    LCD_Position(3, 0u);
    LCD_PrintString("     >JA   nee     ");
    }
    
    
    if(gekozenkanaal == 1){
    LCD_Position(0, 19u);    
    LCD_PutChar(LCD_CUSTOM_0);
    LCD_Position(1, 19u);
    LCD_PrintString("2");
    LCD_Position(2, 19u);
    LCD_PrintString("3");
    LCD_Position(3, 19u);
    LCD_PrintString("4");
    }
    
    if(gekozenkanaal == 2){
    LCD_Position(0, 19u);
    LCD_PrintString("1");
    LCD_Position(1, 19u);    
    LCD_PutChar(LCD_CUSTOM_1);
    LCD_Position(2, 19u);
    LCD_PrintString("3");
    LCD_Position(3, 19u);
    LCD_PrintString("4");
    }
    
    if(gekozenkanaal == 3){
    LCD_Position(0, 19u);
    LCD_PrintString("1");
    LCD_Position(1, 19u);
    LCD_PrintString("2");
    LCD_Position(2, 19u);    
    LCD_PutChar(LCD_CUSTOM_2);
    LCD_Position(3, 19u);
    LCD_PrintString("4");
    }
    
    if(gekozenkanaal == 4){
    LCD_Position(0, 19u);
    LCD_PrintString("1");
    LCD_Position(1, 19u);
    LCD_PrintString("2");
    LCD_Position(2, 19u);
    LCD_PrintString("3");
    LCD_Position(3, 19u);    
    LCD_PutChar(LCD_CUSTOM_3);
    }
    
    return(0);
}