#include "project.h"
#include <stdlib.h>
#include "initialisatie.h"

/**********************************************************************
*       Globale Variabelen
***********************************************************************/
int resetmenuarmatuur = True;

/**********************************************************************
*       Variabelen
***********************************************************************/
int scrolmenu;

int toggle1 = 0;
int refresh11 = 0;
int refresh12 = 0;

int toggle2 = 0;
int refresh21 = 0;
int refresh22 = 0;

int v;
int h;
int cursormenu = 0;
int cursormenuprint;
char tempchar;


/**********************************************************************
*       Functies
***********************************************************************/
int sSELECTARMATUUR(){   
    if(inactive == 1){
        nextstate = SELECTKANAAL;
    }
    menuarmatuur();
    
    if(inactive == 0){
        if(button == False){
            nextstate = SELECTARMATUUR;
        }
        if(button == True){
            nextstate = BEVESTIGING; // NEXTSTATE; //VOEG TOE NEXT STATE LATER
            button = False;
            resetmenuarmatuur = True;
    //        CHOOSENARMATURE = encoder;
        }
    }
return(nextstate);
}

void menuarmatuur(void){
    if(resetmenuarmatuur == True){
        QuadDec_SetCounter(0);
        cursor = 0;
        cursormenu = 0;
        encoder = 0;
        toggle1 = 0;
        toggle2 = 0;
        
        writecursorarmatuur();
        menustabielarmatuur();
        resetmenuarmatuur = False;
    }
    
        encoder = QuadDec_GetCounter();
        
//        Als QD lager is dan 0 set de counter naar maximale waarde.
        if (encoder <= - 1){
            QuadDec_SetCounter(MAXARM - 1);  
            encoder = MAXARM - 1 ;
            cursor = cursor - 2;
        }
        
//        Als QD hoger is dan maximale waarde set counter naar minimale waarde (0).
        if (encoder >= MAXARM){
            QuadDec_SetCounter(0); 
            encoder = 0;
            cursor = cursor + 2;
        }
        
        PWMTEST_WriteCompare(encoder);
        
//      Als er verandering is in de quadrature decoder word de cursor omhoog of naar beneden geschoven.
        refresh11 = encoder;       
        if(toggle1 == 1){
            toggle1 = 0;
            if(refresh11 != refresh12){
                inactive = 0;
                InactivityTimer_WriteCounter(INACTIVETIMERVALUE);
            }
            if(inactive <=0){
                if(refresh11 > refresh12){
                    cursor++;
                    writecursorarmatuur();
                }
                if(refresh11 < refresh12){
                    cursor--;
                    writecursorarmatuur();
                }
                if(refresh11 == refresh12){
                    menustabielarmatuur();
                    writecursorarmatuur();
                }
            }
        }
        if(toggle1 == 0){
            toggle1 = 1;
            refresh12 = refresh11;
        }  
}

void writecursorarmatuur(){
    
    //Als de cursor buiten het bereik van de 4 lijnen komt word hij terug in het bereik gezet.
    if(cursor >= 4){
        menuuparmatuur();
        cursor = 3;
    }
    if(cursor <= -1){
        menudownarmatuur();
        cursor = 0;
    }

    
    //Write Cursor down
    LCD_Position(0, 0u);
    LCD_PrintString(" ");
    LCD_Position(1, 0u);
    LCD_PrintString(" ");                
    LCD_Position(2, 0u);
    LCD_PrintString(" ");   
    LCD_Position(3, 0u);
    LCD_PrintString(" ");                
    //WRITE cursor
    LCD_Position(cursor, 0u);
    LCD_PrintString(">");  
    
}

void menustabielarmatuur(){
    v = 0;
    h = 0;        
    while(v != 4 && h != 19){

        for(v=0; v < 4; ++v){
            for(h=0; h < 19; ++h){
                if(cursormenu == MAXARM){
                    cursormenu = 0;  
                }
                
                cursormenuprint = cursormenu + v;
                
                if(cursormenuprint >= MAXARM){
                    cursormenuprint = cursormenuprint - MAXARM;   
                }
                if(cursormenuprint < 0){
                    cursormenuprint = cursormenuprint + MAXARM;       
                }
                
            tempchar = ARMATUURBENAMING[cursormenuprint][h];
            LCD_Position(v, h + 1);
            LCD_PutChar(tempchar);
            }
        }
    }
}

void menuuparmatuur(){
    cursormenu++;
    v = 0;
    h = 0;        
    while(v != 4 && h != 19){

        for(v=0; v < 4; ++v){
            for(h=0; h < 19; ++h){
                if(cursormenu == MAXARM){
                    cursormenu = 0;  
                }
                
                cursormenuprint = cursormenu + v;
                
                if(cursormenuprint >= MAXARM){
                    cursormenuprint = cursormenuprint - MAXARM;   
                }
                if(cursormenuprint < 0){
                    cursormenuprint = cursormenuprint + MAXARM;       
                }
                
            tempchar = ARMATUURBENAMING[cursormenuprint][h];
            LCD_Position(v, h + 1);
            LCD_PutChar(tempchar);
            }
        }
    }
}

void menudownarmatuur(){
    cursormenu--;
    v = 0;
    h = 0;        
    while(v != 4 && h != 19){

        for(v=0; v < 4; ++v){
            for(h=0; h < 19; ++h){
                if(cursormenu == - 1){
                    cursormenu = MAXARM - 1; 
                }
                
                cursormenuprint = cursormenu + v;
                
                if(cursormenuprint >= MAXARM){
                    cursormenuprint = cursormenuprint - MAXARM;   
                }
                if(cursormenuprint < 0){
                    cursormenuprint = cursormenuprint + MAXARM;       
                }
                
            tempchar = ARMATUURBENAMING[cursormenuprint][h];
            LCD_Position(v, h + 1);
            LCD_PutChar(tempchar);
            }
        }
    }
}